flowMC
======

**Normalizing-flow enhanced sampling package for probabilistic inference**


![](logo_0810.png)

[![](https://badgen.net/badge/Read/the doc/blue)](https://flowMC.readthedocs.io/en/latest/)
[![](https://badgen.net/badge/License/MIT/blue)](https//github.com/kazewong/flowMC/blob/Packaging/LICENSE)



flowMC is a Jax-based python package for normalizing-flow enhanced Markov chain Monte Carlo (MCMC) sampling.
The code is open source under MIT license, and it is under active development.

- Just-in-time compilation is supported.
- Native support for GPU acceleration.
- Suit for problems with multi-modality and complex geometry.

Four steps to use flowMC's guide
================================

1. You can find installation info, a basic example, and some design and guiding principles of `flowMC` in the [quickstart](quickstart.md).
2. In tutorials, we have a set of pedagogical notebooks that will give you a better understanding of the package infrastructure and a number of common use cases.
3. We list some community examples in [community_example](communityExamples.md), so users can see whether there is a similar use case they can adopt their code quickly.
4. Finally, we have a list of frequently asked questions in [FAQ](FAQ.md).

   